//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%46F4094E03CE.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%46F4094E03CE.cm

//## begin module%46F4094E03CE.cp preserve=no
//## end module%46F4094E03CE.cp

//## Module: OGIPTableDeferRead%46F4094E03CE; Package specification
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/Component/OGIPTable/OGIPTableDeferRead.h

#ifndef OGIPTABLEDEFERREAD_H
#define OGIPTABLEDEFERREAD_H 1

//## begin module%46F4094E03CE.additionalIncludes preserve=no
//## end module%46F4094E03CE.additionalIncludes

//## begin module%46F4094E03CE.includes preserve=yes
#include <xsTypes.h>
//## end module%46F4094E03CE.includes

// TableAccess
#include <XSModel/Model/Component/OGIPTable/TableAccess.h>
//## begin module%46F4094E03CE.declarations preserve=no
//## end module%46F4094E03CE.declarations

//## begin module%46F4094E03CE.additionalDeclarations preserve=yes
namespace CCfits {
   class ExtHDU;
}
//## end module%46F4094E03CE.additionalDeclarations


//## begin OGIPTableDeferRead%46F4473A0166.preface preserve=yes
//## end OGIPTableDeferRead%46F4473A0166.preface

//## Class: OGIPTableDeferRead%46F4473A0166
//## Category: XSModel::Model::Component::OGIPTable%3D2EE54A03A6
//## Subsystem: XSModel::Model::Component::OGIPTable%3D2EE58E0084
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class OGIPTableDeferRead : public TableAccess  //## Inherits: <unnamed>%46F4475D03C5
{
  //## begin OGIPTableDeferRead%46F4473A0166.initialDeclarations preserve=yes
  //## end OGIPTableDeferRead%46F4473A0166.initialDeclarations

  public:
    //## Constructors (generated)
      OGIPTableDeferRead();

    //## Destructor (generated)
      virtual ~OGIPTableDeferRead();


    //## Other Operations (specified)
      //## Operation: clone%46F7CA4901B0
      virtual OGIPTableDeferRead* clone ();

      //## Operation: initialRead%46F7CA7E0133
      virtual void initialRead (CCfits::ExtHDU& spectraExt, const size_t nEngs, const size_t nAddPars, const bool isSameAsPrev);

      //## Operation: initialAccessRows%46F7CAA103A3
      virtual void initialAccessRows (const IntegerArray& rowNumbers, const size_t nAddPars);

      //## Operation: getSpectrumEntries%46F7CAA2003C
      virtual void getSpectrumEntries (const size_t iEng, Real* values);

      //## Operation: getVarianceEntries%46F7CAA200C0
      virtual void getVarianceEntries (const size_t iEng, Real* values);

      //## Operation: getAddSpectra%46F7CAA20141
      virtual void getAddSpectra (const size_t iEng, const size_t iAdd, Real* values);

      //## Operation: getAddVariance%46F7CAA201C4
      virtual void getAddVariance (const size_t iEng, const size_t iAdd, Real* values);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: isError%46F7DC53023A
      virtual bool isError () const;

      //## Attribute: isAddParamError%46F7F4F600A0
      virtual const BoolArray& isAddParamError () const;

    // Additional Public Declarations
      //## begin OGIPTableDeferRead%46F4473A0166.public preserve=yes
      //## end OGIPTableDeferRead%46F4473A0166.public

  protected:
    // Additional Protected Declarations
      //## begin OGIPTableDeferRead%46F4473A0166.protected preserve=yes
      //## end OGIPTableDeferRead%46F4473A0166.protected

  private:
    //## Constructors (generated)
      OGIPTableDeferRead(const OGIPTableDeferRead &right);

    //## Assignment Operation (generated)
      OGIPTableDeferRead & operator=(const OGIPTableDeferRead &right);

    // Additional Private Declarations
      //## begin OGIPTableDeferRead%46F4473A0166.private preserve=yes
      //## end OGIPTableDeferRead%46F4473A0166.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: tableVals%4702698D039E
      //## begin OGIPTableDeferRead::tableVals%4702698D039E.attr preserve=no  private: TableValues {U} 
      TableValues m_tableVals;
      //## end OGIPTableDeferRead::tableVals%4702698D039E.attr

      //## Attribute: selectedRows%46F817790330
      //## begin OGIPTableDeferRead::selectedRows%46F817790330.attr preserve=no  private: IntegerArray {U} 
      IntegerArray m_selectedRows;
      //## end OGIPTableDeferRead::selectedRows%46F817790330.attr

      //## begin OGIPTableDeferRead::isError%46F7DC53023A.attr preserve=no  public: bool {U} 
      bool m_isError;
      //## end OGIPTableDeferRead::isError%46F7DC53023A.attr

      //## begin OGIPTableDeferRead::isAddParamError%46F7F4F600A0.attr preserve=no  public: BoolArray {U} 
      BoolArray m_isAddParamError;
      //## end OGIPTableDeferRead::isAddParamError%46F7F4F600A0.attr

      //## Attribute: absPath%46FABCBF0029
      //	It is necessary to store the table file location since
      //	this class will need to reopen the file each time
      //	readTableRows is called.
      //## begin OGIPTableDeferRead::absPath%46FABCBF0029.attr preserve=no  private: string {U} 
      string m_absPath;
      //## end OGIPTableDeferRead::absPath%46FABCBF0029.attr

    // Additional Implementation Declarations
      //## begin OGIPTableDeferRead%46F4473A0166.implementation preserve=yes
      //## end OGIPTableDeferRead%46F4473A0166.implementation

};

//## begin OGIPTableDeferRead%46F4473A0166.postscript preserve=yes
//## end OGIPTableDeferRead%46F4473A0166.postscript

// Class OGIPTableDeferRead 

//## Get and Set Operations for Class Attributes (inline)

inline bool OGIPTableDeferRead::isError () const
{
  //## begin OGIPTableDeferRead::isError%46F7DC53023A.get preserve=no
  return m_isError;
  //## end OGIPTableDeferRead::isError%46F7DC53023A.get
}

inline const BoolArray& OGIPTableDeferRead::isAddParamError () const
{
  //## begin OGIPTableDeferRead::isAddParamError%46F7F4F600A0.get preserve=no
  return m_isAddParamError;
  //## end OGIPTableDeferRead::isAddParamError%46F7F4F600A0.get
}

//## begin module%46F4094E03CE.epilog preserve=yes
//## end module%46F4094E03CE.epilog


#endif
